local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')
local Mm = E:GetModule('Minimap')
local DTB = E:GetModule('DTBars')
local M = E:GetModule('Misc');

E.Minimap = Mm;

ElvUI_DTBars = CreateFrame('Frame', "ElvUI_DTBars", E.UIParent)
ElvUI_DTBars.version = '4'

--------------------------------------------------------
-- System Settable Variables
--------------------------------------------------------


local top_bar, bottom_bar, rep_bar, lchat_tab
local rchat_tab, rchat_tab2, extra_one, extra_two, extra_three

--------------------------------------------------------
-- Language Variables
--------------------------------------------------------


L['Top_DataBar'] = 'Top Datatext';
L['Bottom_DataBar'] = 'Bottom Datatext';
L['RepDataBar'] = 'Rep Datatext';
L['LeftChatDataBar'] = 'Left Chat Tab';
L['RightChatDataBar'] = 'Right Chat Tab';
L['RightChatDataBar2'] = 'Right Chat Tab 2';
L['ExtraPanelOne'] = 'Extra One';
L['ExtraPanelTwo'] = 'Extra Two';
L['ExtraPanelThree'] = 'Extra Three';

------DAS CODE------

--------------------------------------------------------
-- Top Bar
--------------------------------------------------------

db = db or {}

top_bar = CreateFrame('Frame', 'Top_DataBar', E.UIParent)
top_bar.db = { key='Top_DataBar', value = true }
DT:RegisterPanel(top_bar, 3, 'ANCHOR_BOTTOM', 0, -4)
function TopBarDP()
	top_bar:Point("TOP", E.UIParent, "TOP", 0, -E.mult)
	top_bar:SetTemplate('Default', true)
	top_bar:SetFrameStrata('LOW')
	top_bar:SetScript('OnShow', function(self) 
		self:Size(E.db.datatexts.DTBars.Top_DataBar.Width, 22); 
		E:CreateMover(self, "TopBarMover", "Top Datatext Frame") 
	end)
	top_bar:Hide()
end

--------------------------------------------------------
-- Bottom Bar
--------------------------------------------------------

bottom_bar = CreateFrame('Frame', 'Bottom_DataBar', E.UIParent)
bottom_bar.db = {key ='Bottom_DataBar', value = true}
DT:RegisterPanel(bottom_bar, 3, 'ANCHOR_BOTTOM', 0, -4)
function BottomBarDP()
	bottom_bar:SetTemplate('Default', true)
	bottom_bar:SetFrameStrata('LOW')
	bottom_bar:SetFrameLevel(1)
	bottom_bar:Point('BOTTOM', E.UIParent, 'BOTTOM', 0, -E.mult - 3)
	bottom_bar:SetScript('OnShow', function(self) 
		self:Size(E.db.datatexts.DTBars.Bottom_DataBar.Width, 22); 
		E:CreateMover(self, "BottomBarMover", "Bottom Datatext Frame") 
	end)
	bottom_bar:Hide()
end

--------------------------------------------------------
-- Rep Bar 
--------------------------------------------------------

local function rep_bar_setup()
	rep_bar:HookScript('OnUpdate', function() 
		local parent_alpha = ElvUI_ReputationBar:GetAlpha()
		if rep_bar:GetAlpha() ~= parent_alpha then rep_bar:SetAlpha( parent_alpha) end
	end )	
end

rep_bar = CreateFrame('Frame', 'RepDataBar', E.UIParent)
rep_bar.db = {key='RepDataBar', value = true}
DT:RegisterPanel(rep_bar, 1, 'ANCHOR_BOTTOM', 0, -4)
function RepBarDP()
	rep_bar:Point("TOPLEFT", ElvUI_ReputationBar, "BOTTOMLEFT", 0, -E.mult)
	rep_bar:SetTemplate('Default', true)
	rep_bar:Point("TOPLEFT", ElvUI_ReputationBar, "BOTTOMLEFT", 0, -E.mult); 
	rep_bar:SetFrameStrata('BACKGROUND')
	rep_bar:Hide()
	rep_bar:SetHeight(22)
	
end

--------------------------------------------------------
-- Left Chat Tab
--------------------------------------------------------

local function lchat_tab_setup()
	do
		lchat_tab:Size(LeftChatTab:GetWidth() / 3, 22)
		lchat_tab:Point("TOPRIGHT", LeftChatTab, "TOPRIGHT", 0, -E.mult)
		lchat_tab:SetFrameStrata('LOW')
		LeftChatTab:HookScript("OnHide", function() lchat_tab:Hide() end)
		LeftChatTab:HookScript("OnShow", function() lchat_tab:Show() end)		
	end
end

do
	lchat_tab = CreateFrame('Frame', 'LeftChatDataBar', E.UIParent)
	lchat_tab.db = {key='LeftChatDataBar', value = true}
	DT:RegisterPanel(lchat_tab, 1, 'ANCHOR_BOTTOM', 0, -4)
	lchat_tab:Hide()
end

--------------------------------------------------------
-- Right Chat Tab 1
--------------------------------------------------------

local function rchat_tab_setup()
	do
		rchat_tab:Size(RightChatPanel:GetWidth() /3, 22)
		rchat_tab:Point("RIGHT", RightChatDataBar2, "LEFT")
		rchat_tab:SetFrameStrata('LOW')

		rchat_tab2:Size((RightChatPanel:GetWidth() / 3),22)
		rchat_tab2:Point("TOPRIGHT", RightChatTab, "TOPRIGHT", 0, 0)
		rchat_tab2:SetFrameStrata('LOW')

		RightChatTab:HookScript("OnHide", function() 
			rchat_tab:Hide() 
			rchat_tab2:Hide() 
		end)
		RightChatTab:HookScript("OnShow", function() 
			rchat_tab:Show() 
			rchat_tab:SetAlpha(RightChatTab:GetAlpha()) 
			rchat_tab2:Show() 
			rchat_tab2:SetAlpha(RightChatTab:GetAlpha()) 
		end)
	end
end

 do
	rchat_tab = CreateFrame('Frame', 'RightChatDataBar', E.UIParent)
	rchat_tab.db ={key='RightChatDataBar', value = true}
	DT:RegisterPanel(rchat_tab, 1, 'ANCHOR_BOTTOM', 0, -4)
	rchat_tab:Hide()
end

--------------------------------------------------------
-- Right Chat Tab 2
--------------------------------------------------------

 do
	rchat_tab2 = CreateFrame('Frame', 'RightChatDataBar2', E.UIParent)
	rchat_tab2.db = {key='RightChatDataBar2', value = true}
	DT:RegisterPanel(rchat_tab2, 1, 'ANCHOR_BOTTOM', 0, -4)
	rchat_tab2:Hide()
end

--------------------------------------------------------
--ExtraOne
--------------------------------------------------------

	extra_one = CreateFrame('Frame', 'ExtraPanelOne', E.UIParent)
	extra_one.db = { key='ExtraPanelOne', value = true }
	function ExtraOneDP()
		extra_one:SetTemplate('Default', true)
		extra_one:SetFrameStrata('HIGH')
		extra_one:SetFrameLevel(1)
		extra_one:Point("LEFT", Bottom_DataBar, "RIGHT", 1, 1)
		extra_one:SetScript('OnShow', function(self)
			self:Size(E.db.datatexts.DTBars.ExtraPanelOne.Width, 22);
			E:CreateMover(extra_one, "ExtraOneMover", "Extra One")
		end)
		extra_one:Hide()
	end
	


--------------------------------------------------------
--ExtraTwo
--------------------------------------------------------

	extra_two = CreateFrame('Frame', 'ExtraPanelTwo', E.UIParent)
	extra_two.db = { key='ExtraPanelTwo', value = true }
	function ExtraTwoDP()
		extra_two:SetTemplate('Default', true)
		extra_two:SetFrameStrata('HIGH')
		extra_two:SetFrameLevel(1)
		extra_two:Point("LEFT", ExtraPanelOne, "RIGHT", 0, 0)
		extra_two:SetScript('OnShow', function(self)
			self:Size(E.db.datatexts.DTBars.ExtraPanelTwo.Width, 22);
			E:CreateMover(extra_two, "ExtraTwoMover", "Extra Two")
		end)
		extra_two:Hide()
	end
	
	
--------------------------------------------------------
--ExtraThree
--------------------------------------------------------

	extra_three = CreateFrame('Frame', 'ExtraPanelThree', E.UIParent)
	extra_three.db = { key='ExtraPanelThree', value = true }
	function ExtraThreeDP()
		extra_three:SetTemplate('Default', true)
		extra_three:SetFrameStrata('HIGH')
		extra_three:SetFrameLevel(1)
		extra_three:Point("RIGHT", Bottom_DataBar, "LEFT", -1, 1)
		extra_three:SetScript('OnShow', function(self)
			self:Size(E.db.datatexts.DTBars.ExtraPanelThree.Width, 22);
			E:CreateMover(extra_three, "ExtraThreeMover", "Extra Three")
		end)
		extra_three:Hide()
	end
	
--------------------------------------------------------
--Updating Frames
--------------------------------------------------------

function DT:UpdateFrames()
	DT:FramesVisibility()
	DT:FramesSize()
	DT:PetBattleHide()
	DT:SnapMiniMap()
	DT:MouseOver()
end

function DT:MouseOver()

	if E.db.datatexts.DTBars.RepDataBar.MouseOver then
		rep_bar:SetScript("OnUpdate", function (self,event,...)
			if MouseIsOver(RepDataBar) then
				rep_bar:SetAlpha(1)
			else
				rep_bar:SetAlpha(0)
			end
		end)
		
	end
	
	if not E.db.datatexts.DTBars.RepDataBar.MouseOver then
		rep_bar:SetScript("OnUpdate", nil)
		rep_bar:SetAlpha(1)
	end
	
	if E.db.datatexts.DTBars.ExtraPanelOne.MouseOver then
		extra_one:SetScript("OnUpdate", function (self,event,...)
			if MouseIsOver(ExtraPanelOne) then
				extra_one:SetAlpha(1)
			else
				extra_one:SetAlpha(0)
			end
		end)
		
	end
	
	if not E.db.datatexts.DTBars.ExtraPanelOne.MouseOver then
		extra_one:SetScript("OnUpdate", nil)
		extra_one:SetAlpha(1)
	end
	
	
	
	if E.db.datatexts.DTBars.ExtraPanelTwo.MouseOver then
		extra_two:SetScript("OnUpdate", function (self,event,...)
			if MouseIsOver(ExtraPanelTwo) then
				extra_two:SetAlpha(1)
			else
				extra_two:SetAlpha(0)
			end
		end)
		
	end
	
	if not E.db.datatexts.DTBars.ExtraPanelTwo.MouseOver then
		extra_two:SetScript("OnUpdate", nil)
		extra_two:SetAlpha(1)
	end
	
	
	if E.db.datatexts.DTBars.ExtraPanelThree.MouseOver then
		extra_three:SetScript("OnUpdate", function (self,event,...)
			if MouseIsOver(ExtraPanelThree) then
				extra_three:SetAlpha(1)
			else
				extra_three:SetAlpha(0)
			end
		end)
		
	end
	
	if not E.db.datatexts.DTBars.ExtraPanelThree.MouseOver then
		extra_three:SetScript("OnUpdate", nil)
		extra_three:SetAlpha(1)
	end


end


function DT:YPoints()
	local location = E:GetScreenQuadrant(ElvUI_ReputationBar)
	if location == "TOP" then
	print("Top Screen")
		rep_bar:Point("TOPLEFT", ElvUI_ReputationBar, "BOTTOMLEFT", 0, -E.mult)
	elseif location == "BOTTOM" then
	print("Bottom Screen")
		rep_bar:Point("BOTTOMLEFT", ElvUI_ReputationBar, "TOPLEFT", 0, -E.mult)
	end

end

function DT:FramesVisibility()
	if E.db.datatexts.DTBars.Top_DataBar.Enabled then
		top_bar:Show()
	else
		top_bar:Hide()
	end
	
	if E.db.datatexts.DTBars.Bottom_DataBar.Enabled then
		bottom_bar:Show()
	else
		bottom_bar:Hide()
	end
	
	if E.db.datatexts.DTBars.LeftChatDataBar.Enabled then
		lchat_tab:Show()
	else
		lchat_tab:Hide()
	end
	
	if E.db.datatexts.DTBars.RightChatDataBar.Enabled then
		rchat_tab:Show()
		rchat_tab2:Show()
	else
		rchat_tab:Hide()
		rchat_tab2:Hide()
	end
	
	if E.db.datatexts.DTBars.RepDataBar.Enabled then
		if E.db.datatexts.DTBars.RepDataBar.MiniMapSnap or ElvUI_ReputationBar:IsShown() and not E.db.datatexts.DTBars.RepDataBar.MiniMapSnap then
			rep_bar:Show()
		elseif not ElvUI_ReputationBar:IsShown() then
			rep_bar:Hide()
		end
	else
		rep_bar:Hide()
	
end

	
	if E.db.datatexts.DTBars.ExtraPanelOne.Enabled then
		extra_one:Show()
	else
		extra_one:Hide()
	end
	
	if E.db.datatexts.DTBars.ExtraPanelTwo.Enabled then
		extra_two:Show()
	else
		extra_two:Hide()
	end
	
	if E.db.datatexts.DTBars.ExtraPanelThree.Enabled then
		extra_three:Show()
	else
		extra_three:Hide()
	end
	
	
	
end

function DT:Watched()

	local name = GetWatchedFactionInfo()
	
	if not name and ElvUI_ReputationBar:IsShown() and E.db.datatexts.DTBars.RepDataBar.Enabled then
		rep_bar:Hide()
	else 
		rep_bar:Show()
	end

end

function DT:FramesSize()
	top_bar:SetSize(E.db.datatexts.DTBars.Top_DataBar.Width, 22)
	bottom_bar:SetSize(E.db.datatexts.DTBars.Bottom_DataBar.Width, 22)
	extra_one:SetSize(E.db.datatexts.DTBars.ExtraPanelOne.Width, 22)
	extra_two:SetSize(E.db.datatexts.DTBars.ExtraPanelTwo.Width, 22)
	extra_three:SetSize(E.db.datatexts.DTBars.ExtraPanelThree.Width, 22)
	DT:UpdateAllDimensions()
end

function DT:PetBattleHide()
	if E.db.datatexts.DTBars.Top_DataBar.PetBattleHide then
		E.FrameLocks["Top_DataBar"] = true
	else
		E.FrameLocks["Top_DataBar"] = nil
	end
	
	if E.db.datatexts.DTBars.Bottom_DataBar.PetBattleHide then
		E.FrameLocks["Bottom_DataBar"] = true
	else
		E.FrameLocks["Bottom_DataBar"] = nil
	end
	
	if E.db.datatexts.DTBars.ExtraPanelOne.PetBattleHide then
		E.FrameLocks["ExtraPanelOne"] = true
	else
		E.FrameLocks["ExtraPanelOne"] = nil
	end
	
	if E.db.datatexts.DTBars.ExtraPanelTwo.PetBattleHide then
		E.FrameLocks["ExtraPanelTwo"] = true
	else
		E.FrameLocks["ExtraPanelTwo"] = nil
	end
	
	if E.db.datatexts.DTBars.ExtraPanelThree.PetBattleHide then
		E.FrameLocks["ExtraPanelThree"] = true
	else
		E.FrameLocks["ExtraPanelThree"] = nil
	end

end

function DT:SnapMiniMap()

	if E.db.datatexts.DTBars.RepDataBar.MiniMapSnap then
		rep_bar:SetWidth(MMHolder:GetWidth())
		rep_bar:SetPoint("TOPLEFT", MMHolder, "BOTTOMLEFT", 0, -E.mult)
		
	else
		rep_bar:SetWidth(ElvUI_ReputationBar:GetWidth())
		rep_bar:Point("TOPLEFT", ElvUI_ReputationBar, "BOTTOMLEFT", 0, -E.mult)
	end

end

--------------------------------------------------------
--Initialize
--------------------------------------------------------
--DT.InitializeBar = DT.Initialize
function DTB:Initialize()
	--self:InitializeBar()
	--self:RegisterEvent("PLAYER_ENTERING_WORLD", "Loading")
	TopBarDP()
	BottomBarDP()
	RepBarDP()
	ExtraOneDP()
	ExtraTwoDP()
	ExtraThreeDP()	
	
	rep_bar_setup()
	rchat_tab_setup()
	lchat_tab_setup()
	
	if E.db.datatexts.DTBars.ExtraPanelOne.DataPlacements == 1 then
		DT:RegisterPanel(extra_one, 1, 'ANCHOR_BOTTOM', 0, -4)	
	elseif E.db.datatexts.DTBars.ExtraPanelOne.DataPlacements == 3 then
		DT:RegisterPanel(extra_one, 3, 'ANCHOR_BOTTOM', 0, -4)
	end
	
	if E.db.datatexts.DTBars.ExtraPanelTwo.DataPlacements == 1 then
		DT:RegisterPanel(extra_two, 1, 'ANCHOR_BOTTOM', 0, -4)
	elseif E.db.datatexts.DTBars.ExtraPanelTwo.DataPlacements == 3 then
		DT:RegisterPanel(extra_two, 3, 'ANCHOR_BOTTOM', 0, -4)
	end

	if E.db.datatexts.DTBars.ExtraPanelThree.DataPlacements == 1 then
		DT:RegisterPanel(extra_three, 1, 'ANCHOR_BOTTOM', 0, -4)	
	elseif E.db.datatexts.DTBars.ExtraPanelThree.DataPlacements == 3 then
		DT:RegisterPanel(extra_three, 3, 'ANCHOR_BOTTOM', 0, -4)
	end
	
	DT:UpdateFrames()
	
	DT:RegisterEvent("UPDATE_FACTION" , "FramesVisibility")
	
	hooksecurefunc(M, "EnableDisable_ReputationBar", DT.FramesVisibility)
end















