local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

E.Options.args.DTBars = {
	type = "group",
	name = "DTBars",
	order = 600,
	args = {
		header = {
			order = 1,
			type = "header",
			name = "ElvUI_DTBars",
		},
		info = {
			order = 2,
			type = "description",
			name = "DTBars Information",
		},
	}
}


E.Options.args.DTBars.args.Bars = {
	type = "group",
	name = "Datatext Bars",
	order = 600,
	args = {
		topDataBar = {
			order = 1,
			type = "group",
			name = "Top DataText Bar",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.Top_DataBar.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.Top_DataBar.Enabled = value; DT:UpdateFrames() end
				},
				width = {
					type = "range",
					order = 2,
					name = "Width",
					min = 250, max = 550, step = 1,
					get = function(info) return E.db.datatexts.DTBars.Top_DataBar.Width end,
					set = function(info, value) E.db.datatexts.DTBars.Top_DataBar.Width = value; DT:UpdateFrames() end
				},
				petBattle = {
					type = "toggle",
					order = 3,
					name = "Hide in Pet Battle",
					get = function(info) return E.db.datatexts.DTBars.Top_DataBar.PetBattleHide end,
					set = function(info, value) E.db.datatexts.DTBars.Top_DataBar.PetBattleHide = value; DT:UpdateFrames() end
				},
			},
		},
		bottomDataBar = {
			order = 2,
			type = "group",
			name = "Bottom DataText Bar",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.Bottom_DataBar.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.Bottom_DataBar.Enabled = value; DT:UpdateFrames() end
				},
				width = {
					type = "range",
					order = 2,
					name = "Width",
					min = 250, max = 550, step = 1,
					get = function(info) return E.db.datatexts.DTBars.Bottom_DataBar.Width end,
					set = function(info, value) E.db.datatexts.DTBars.Bottom_DataBar.Width = value; DT:UpdateFrames() end,
				},
				petBattle = {
					type = "toggle",
					order = 3,
					name = "Hide in Pet Battle",
					get = function(info) return E.db.datatexts.DTBars.Bottom_DataBar.PetBattleHide end,
					set = function(info, value) E.db.datatexts.DTBars.Bottom_DataBar.PetBattleHide = value; DT:UpdateFrames() end
				},
			}
		},
		leftChat = {
			order = 3,
			type = "group",
			name = "Left Chat Tab",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.LeftChatDataBar.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.LeftChatDataBar.Enabled = value; DT:UpdateFrames() end,
				},	
			}
		},
		rightChat = {
			order = 4,
			type = "group",
			name = "Right Chat Tab",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.RightChatDataBar.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.RightChatDataBar.Enabled = value; DT:UpdateFrames() end,
				}
			}
		},
		RepBar = {
			order = 5,
			type = "group",
			name = "Rep Data Bar",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.RepDataBar.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.RepDataBar.Enabled = value; DT:UpdateFrames() end,
				},
				mouseover = {
					type = "toggle",
					order = 2,
					name = "Mouseover",
					get = function(info) return E.db.datatexts.DTBars.RepDataBar.MouseOver end,
					set = function(info, value) E.db.datatexts.DTBars.RepDataBar.MouseOver = value; DT:MouseOver() end,
				},
				repsnap = {
					type = "toggle",
					order = 3,
					name = "Snap to Minimap",
					get = function(info) return E.db.datatexts.DTBars.RepDataBar.MiniMapSnap end,
					set = function(info, value) E.db.datatexts.DTBars.RepDataBar.MiniMapSnap = value; DT:SnapMiniMap() ; DT:FramesVisibility() end,
				}
			}
		},
		extraone = {
			order = 6,
			type = "group",
			name = "Extra One",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelOne.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelOne.Enabled = value; DT:UpdateFrames() end,
				},
				width = {
					type = "range",
					order = 2,
					name = "Width",
					min = 50, max = 500, step = 1,
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelOne.Width end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelOne.Width = value; DT:UpdateFrames(); end,
				},
				petBattle = {
					type = "toggle",
					order = 3,
					name = "Hide in Pet Battle",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelOne.PetBattleHide end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelOne.PetBattleHide = value; DT:UpdateFrames() end
				},
				mouseover = {
					type = "toggle",
					order = 4,
					name = "Mouseover",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelOne.MouseOver end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelOne.MouseOver = value; DT:MouseOver() end,
				},
				dataplacement = {
					type = "range",
					order = 5,
					name = "Data Places",
					min = 1, max = 3, step = 2,
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelOne.DataPlacements end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelOne.DataPlacements = value; E:StaticPopup_Show("CONFIG_RL") end,
				},
			},
		},
		extratwo = {
			order = 7,
			type = "group",
			name = "Extra Two",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelTwo.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelTwo.Enabled = value; DT:UpdateFrames() end,
				},
				width = {
					type = "range",
					order = 2,
					name = "Width",
					min = 50, max = 500, step = 1,
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelTwo.Width end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelTwo.Width = value; DT:UpdateFrames(); end,
				},
				petBattle = {
					type = "toggle",
					order = 3,
					name = "Hide in Pet Battle",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelTwo.PetBattleHide end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelTwo.PetBattleHide = value; DT:UpdateFrames() end
				},
				mouseover = {
					type = "toggle",
					order = 4,
					name = "Mouseover",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelTwo.MouseOver end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelTwo.MouseOver = value; DT:MouseOver() end,
				},
				dataplacement = {
					type = "range",
					order = 5,
					name = "Data Places",
					min = 1, max = 3, step = 2,
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelTwo.DataPlacements end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelTwo.DataPlacements = value; E:StaticPopup_Show("CONFIG_RL") end,
				},
			}
		},
		extrathree = {
			order = 8,
			type = "group",
			name = "Extra Three",
			guiInline = true,
			args = {
				enable = {
					type = "toggle",
					order = 1,
					name = "Enabled",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelThree.Enabled end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelThree.Enabled = value; DT:UpdateFrames() end,
				},
				width = {
					type = "range",
					order = 2,
					name = "Width",
					min = 50, max = 500, step = 1,
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelThree.Width end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelThree.Width = value; DT:UpdateFrames(); end,
				},
				petBattle = {
					type = "toggle",
					order = 3,
					name = "Hide in Pet Battle",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelThree.PetBattleHide end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelThree.PetBattleHide = value; DT:UpdateFrames() end
				},
				mouseover = {
					type = "toggle",
					order = 4,
					name = "Mouseover",
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelThree.MouseOver end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelThree.MouseOver = value; DT:MouseOver() end,
				},
				dataplacement = {
					type = "range",
					order = 5,
					name = "Data Places",
					min = 1, max = 3, step = 2,
					get = function(info) return E.db.datatexts.DTBars.ExtraPanelThree.DataPlacements end,
					set = function(info, value) E.db.datatexts.DTBars.ExtraPanelThree.DataPlacements = value; E:StaticPopup_Show("CONFIG_RL") end,
				},
			}
		},		
	}
}